use Win32::GUI;
use Win32::API;
use ParsPerl;
use WinStRes;
use WinSize;

$SendMessage = new Win32::API ('User32', $_ = 'SendMessage', [I, N, I, P], I)
	or die "missing library function $_";
END {undef $SendMessage}
$Font = new Win32::GUI::Font
(
	-name => "Courier",
	-height => 9,
);
$_ = $0;
s/\.\S{0,3}$//;
%keyword =
(
	-standard => 0x000000,
	-quote    => 0x8060C0,
	-comment  => 0x808000,
	-regex    => 0xC040FF,
	-keyword  => 0xFF0000,
);
if (open TXT, "$_.txt")
{
	$txt = join '', map {s/#.*//, $_} <TXT>;
	close TXT;
	/\[(.*)\]/ ? $col = eval $1 : $keyword{$_} = $col
		for ($txt =~ /\S+/g);
}
new Win32::GUI::Class
(
	-name => '_RichEdit',
	-widget => 'RichEdit',
	-extends => 'RichEdit',
);
$Richer =
'
	-font => $Font,
	#-class => "_RichEdit",
	-addstyle => WS_VSCROLL | WS_HSCROLL,
';
open UI, "$_.ui" or die "can\'t find $_.ui";
$_ = join '', grep !/\(\s*\)/m, <UI>;
close UI;
s/-(width[^,\)]*)/$&,-min$1/;
s/-(height[^,\)]*)/$&,-min$1/;
$Richer =~ s/,\s*$//;
s/-name\W+Rich\W/$&,$Richer/;
#s/^.*Dropdown Style.*$/-addstyle => WS_VSCROLL | 3,/mg;
eval $_;
die "error in $self.ui" unless $Main;
WinSize ($Main,
	-regkey => 'FairyMail\\Perl Explorer',
	Tree => R0B,
	Rich => RB,
);
$Main->Show ();
$0 =~ /[^\\]*$/;
%FileDialog =
(
	-owner => $Main->{-handle},
	-directory => $`,
	-file => $&,
	-filter =>
	[
		'Perl Script' => '*.pl',
		'Perl GUI script' => '*.ui',
		'Perl module' => '*.pm',
		'All files' => '*.*',
	]
);
$images = new Win32::GUI::ImageList (16, 16, 0, 0, 3);
$images->AddBitmap (WinBitmap ($_)) for (RGARROW, RGARROWD, RGARROWI);
$Main->Tree->SetImageList ($images);
ReadScript ();
$PARAPACK = 'VVvvV3vvV32';
$PARAFORMAT = pack $PARAPACK,
	0,						# cbSize (filled in later)
	0x10,					# dwMask
	0,						# wNumbering
	0,						# wReserved
	0,						# dxStartIndent
	0,						# dxRightIndent
	0,						# dxOffset
	2,						# wAlignment
	32,						# cTabCount
	map 480 * $_, (1..32);		# rgxTabs[MAX_TAB_STOPS]
$_ = pack substr ($PARAPACK, 0, 1), length $PARAFORMAT;
substr ($PARAFORMAT, 0, length $_) = $_;
$CHARPACK = 'V6C2A32x2';
$CHARFORMAT = pack $CHARPACK,
	0,						# cbSize (filled in later)
	0,						# dwMask
	0,						# dwEffects
	0,						# yHeight
	0,						# yOffset
	0,						# crTextColor
	0,						# bCharSet
	0,						# bPitchAndFamily
	'Courier New';			# szFaceName[LF_FACESIZE]
$_ = pack substr ($CHARPACK, 0, 1), length $CHARFORMAT;
substr ($CHARFORMAT, 0, length $_) = $_;
$SendMessage->Call ($Main->Rich->{-handle}, 0x447, 0, $PARAFORMAT);
$Main->Rich->SendMessage (0x445, 0, 1);
init ();
exit Win32::GUI::Dialog ();

sub Tree_RightClick
{
	#popup to create new object
}
sub Tree_NodeClick
{
	local ($_, %node, %parent);
	%node = $Main->Tree->ItemInfo ($_[0]);
	if ($node{-text} eq '-properties')
	{
		# all props would be nice
		return;
	}
	%parent = $Main->Tree->ItemInfo ($node{-parent});
	if ($parent{-text} eq '-methods')
	{
		LoadScript ($Main->Rich, $target{-subs}->{$node{-text}});
	}
}
sub Main_Resize_Obsolete
{
	local $_ = $Main->{-height} - $winsize[1];
	$Main->Tree->Resize ($Main->Tree->Width (), $_);
	$Main->Rich->Resize	($Main->{-width} - $winsize[0], $_);
}
sub ReadScript
{
	local ($_, $fina);
	$Main->SetFocus ();
	$fina = $Main->GetOpenFileName
	(
		-title => 'Import Win32-GUI Script',
		%FileDialog
	);
	return unless $fina;
	return ouch ("$fina not found or empty") unless (-s $fina);
	open PLW, $fina or return ouch ("can\'t access $fina");
	#$Main->Script->Text ($fina);
	$fina =~ /[^\\]*$/;
	$FileDialog{-directory} = $`;
	$FileDialog{-file} = $file = $&;
	$_ = join '', <PLW>;
	close PLW;
	unless ($fina =~ /\.ui$/i)
	{
		$fina =~ s/\.\S{1,3}$//;
		if (open PLW, $fina .= '.ui')
		{
			if ($Main->MessageBox ("Include $fina?", "Read Script", MB_YESNO) == 6)
			{
				@_ = <PLW>;
				@_ = grep !/GUI::Dialog/, @_ if /GUI::Dialog/;
				$_ .= "\n=include ui\n$fina\n=cut\n" . join '', @_;
			}
			close PLW;
		}
	}
	%target = import ($_);
	$Main->Tree->Clear ();
	#dumpvar ($Main->Tree->GetRoot (), $file, \%target);
	$root = $Main->Tree->GetRoot ();
	$win = 0;
	for (-methods, @{$target{-window}})
	{
		@meth = @{$target{$_}};
		$node = $Main->Tree->InsertItem
		(
			-parent => $win || $root,
			-text => /^-/ ? $_ : "$meth[0] $_",
			-image => 0,
			-selectedimage => 1,
		);
		unless (/^-/)
		{
			$win ||= $node;
			dumpvar ($node, '-properties', $meth[1]);
			$node = $Main->Tree->InsertItem
			(
				-parent => $node,
				-text => '-methods',
				-image => 0,
				-selectedimage => 1,
			);
			@meth = @{$meth[2]};
		}
		for (sort {lc $a cmp lc $b} @meth)
		{
			$Main->Tree->InsertItem
			(
				-parent => $node,
				-text => $_,
				-image => 2,
				-selectedimage => 2,
			);
		}
	}
}
sub dumpvar
{
	local $item = $Main->Tree->InsertItem
	(
		-parent => $_[0],
		-text => $_[1],
		-image => 0,
		-selectedimage => 1,
	);
	if ($_[2] =~ /^ARRAY/)
	{
		dumpvar ($item, "[$_]", $_[2]->[$_]) for (0..$#{$_[2]});
		return;
	}
	if ($_[2] =~ /^HASH/)
	{
		dumpvar ($item, $_, $_[2]->{$_}) for sort keys %{$_[2]};
		return;
	}
	local $_ = $_[2];
	$_ .= '...' if s/\n.*//s;
	$_ = '=> ' . $_ if $_[1] !~ /^\[/;
	$Main->Tree->ChangeItem
	(	$item,
		-text => "$_[1] $_",
		-image => 2,
		-selectedimage => 2,
	);
}
sub ouch
{
	return $Main->MessageBox (join ("\n", @_), "GUI Object Explorer Error", MB_ICONERROR);
}
sub import
{
	local ($_, $pars, $name, $type, %prop, @meth);
	local ($object, @object, %object, %method);
	$pars = $_ = ParsePerl ParseStrings $_[0];
	%method = ();
	@object = ();
	%object = ();
	if (/\\\$\s*(\w*)[^\$]*GUI::(Window|DialogBox)[^\(]*/)
	{
		$object = $1;
		$type = $2;
		$object{-mainvar} = '$' . $1;
		for (;;)
		{
			@_ = ($`);
			($_, $_[1]) = ParseBlock ($', '(', 1);
			$_[1] =~ s/^[;\s]*//;
			$pars = join '', @_;
			%prop = ();
			$_ = eval '"' . $_ . '"';
			eval '%prop = ' . $_;
			push @object, $name = $prop{-name};
			if ($name)
			{
				@meth = $pars =~ /\$block\{'($name\_\w+)/g;
				$pars =~ s/\$block\{'($name\_\w+)'}\s*;?\s*//g;
				$method{$_} = eval delete $block{$_} for @meth;
				$object{$name} = [$type, {%prop}, [@meth]];
			}
			last unless $pars =~ /\\\$\s*$object\s*->\s*Add(\w*)[^\(]*/;
			$type = $1;
		}
	}
	@meth = $pars =~ /\$block\{'(\w+)/g;
	$method{$_} = eval delete $block{$_} for @meth;
	$object{-subs} = {-main => eval $pars, %method};
	$object{-methods} = [-main, @meth];
	$object{-window} = [@object];
	%block = %method = ();
	@quote = @object = ();
	return %object;
}
sub LoadScript
{
	local ($Rich, $_, $pars, $text, $len, @color, $color, $quote);
	$Rich = shift;
	$Rich->{-text} = $text = '';
	$pars = substr ParseStrings ($_[0]), 1;
#	$pars =~ s/\n/\r\n/g;
	$len = 0;
	while ($pars =~ /(^|[^\\])(\$quote\[(\d+)\]|.$)/s)
	{
		$pars = $';
		$_ = eval '"' . $` . $1 . '"';
		$text .= $_;
		if (defined $3)
		{
			$quote = $quote[$3];
			$color = $keyword{$quote =~ /^[=#]/ ? -comment : -quote};
			$quote =~ s/^(\w*)(?=.)//;
			if ($1)
			{
				push @color, [length $text, length $1, $keyword{-keyword}];
				$text .= $1;
			}
			$color = $keyword{-regex}, $quote =~ s/(\w*)$// if $1 || $quote =~ m!^/!;
			push @color, [length $text, length $quote, $color];
			$text .= $quote;
			if ($1)
			{
				push @color, [length $text, length $1, $keyword{-keyword}];
				$text .= $1;
			}
		}
		while (/\b\w+/)
		{
			$len += length $`;
			$_ = $';
			if (defined $keyword{$&})
			{
				$quote = $&;
				push @color, [$len, length $quote, $keyword{$quote}]
					unless $` =~ /[\$\%\@]\s*(\{\s*)*$/s;
			}
			$len += length $&;
		}
		$len = length $text;
	}
	@quote = ();
	$Rich->Text ($text);
	$Rich->Select (0, 2e9);
	$Rich->SetCharFormat (-color => $keyword{-standard});
	for (@color)
	{
		$Rich->Select ($$_[0], $$_[0] + $$_[1]);
		$Rich->SetCharFormat (-color => $$_[2])
	}
	$Rich->Select (0, 0);
}
sub init
{
	for (LButtonDown, RButtonDown, LButtonUp, RButtonUp, MouseMove, KeyPress,
		Change, Anonymous, GotFocus, LostFocus, Click)
	{
#		eval ("sub Rich_$_\{print\"$_\n\";}");
	}
}
sub Rich_GotFocus
{
#	print $Main->Rich->SendMessage (0x43B, 0, 0), "\n";
}
sub Rich_KeyPress
{
	%var = $Main->Rich->GetCharFormat (0xF800003F);
	$var{-color} &&= sprintf "0x%x", $var{-color};
	$Main->Tree->Clear ();
	local $_ = $Main->Tree->GetRoot ();
	dumpvar ($_, 'CharFormat', \%var);
	$Main->Tree->Expand ($Main->Tree->GetChild ($_));
	1;
}
sub Rich_Change		# testing ...
{
#	print $rc++, " ";
}
